small   define 1     ; small mm
SAVESIDI define 0

        include c:\powerc\macro.asm

        idt copyline
        ldef copyline

        dorg $
fixmask
        db      255
        db      127
        db      63
        db      31
        db      15
        db      7
        db      3
        db      1
   ;
   ;    void copyline(int x, int y, int bits, int source_row){
   ;    also erase source data - uses write mode 3

        org $

        function mypencolor

bits  define bx
mask  define  [bp][-2]
; dx register is storage for variable 'i'

copyline
     enter 2
   ;    static int fixmask[8]={       /* inverted precalculated masks for final write */
   ;      0xff,0x7f,0x3f,0x1f,0x0f,0x07,0x03,0x01 };

   ;       mypencolor(0);          /* use set/reset to clear on the edges */
;        xor    ax,ax
;        push   ax
;        call mypencolor
;        pop    ax
   ;
   ;       bits+= 1;               /* write end point also */
   ;
        getarg bits,3
   ;     inc   bits      no longer writing endpoint
   ;
   ;       offset= 80*y+(i= (x >> 3));        /* determine 1st bit position */
   ;
        getarg   ax,2
        mov     dx,80
        imul    dx
        getarg   dx,1
        sar     dx,1
        sar     dx,1
        sar     dx,1
        add     ax,dx                     ; i is in dx
        mov   di,ax
   ;
   ;       offset2= 80*480 +i;                /* source position, just offscreen */
   ; changed to = 80*source_row + i;

   ;     mov      ax,38400
        getarg   ax,4
        push     dx
        mov      dx,80
        imul     dx
        pop      dx
        add      ax,dx
        mov      si,ax
   ;
   ;       i= x & 7;
   ;
        getarg dx,1
        and     dx,7
   ;
   ;       video= MK_FP( 0xa000, offset );

         mov  ax,0a000h
         mov  es,ax
         cld         ; inc direction
   ;
   ;       mask= 0xff >> i;
   ;
        mov     ax,255
        mov     cl,dl
        sar     ax,cl
        mov     word ptr mask,ax
   ;
   ;    /* mask is inverted because we want to use latched data */
   ;       if( bits + i <= 8 ){                /* just need one write ?? */
   ;
         mov     ax,dx
         add     ax,bits
         cmp     ax,8

       jg    L1L86
   ;
   ;          mask= mask ^ ( mask >> bits );
   ;
        mov     ax,word ptr mask
        mov     cx,bits
        sar     ax,cl
        xor     ax,mask
   ;
   ;          c= *offscreen;                   /* copy the line via latches */
   ;
         mov     ah,byte ptr es:[si]
   ;
   ;          *video= (mask ^ 0xff);
   ;
        xor     al,255
        jmp       L1L198
L1L86:
   ;
   ;          return;
   ;          }
   ;
   ;       bits= bits + i - 8;          /* else more bits in next address */
   ;
        mov     ax,-8
        add     ax,dx
        add     bits,ax
   ;
   ;
   ;    /* set the latches and write the 1st partial bits */
   ;       c= *offscreen++;
   ;
        mov     ah,byte ptr es:[si]
        mov     byte ptr es:[si],0xff    ;erase via set/reset
        inc     si
   ;
   ;       *video++= mask ^ 0xff;
   ;
        mov     al,byte ptr mask
        xor     al,255
    ;    mov     byte ptr es:[di],al
    ;    inc     di
        stosb
   ;
   ;
   ;    /* write 8 bits at a time */
   ;       i= bits >> 3;
   ;
        mov     cx,bits
        sar     cx,1
        sar     cx,1
        sar     cx,1
        inc     cx         ; adjust for loop ( while --i )
        xor    ax,ax       ; clear mask
        jmp       L1L142
L1L114:
   ;
   ;       while( i-- ){
   ;          c= *offscreen++;
   ;
        mov     ah,byte ptr es:[si]      ;load latches
        mov     byte ptr es:[si],0xff    ;erase via set/reset
        inc     si
   ;
   ;          *video++= 0x00;       /* zero bit mask uses just the latched data */
   ;
    ;    mov     byte ptr es:[di],0
    ;    inc    di
    ; xor  ax,ax       ; move outside when fix loop
         stosb
L1L142:
;        mov     ax,cx
;        dec     cx
;        or      ax,ax
;        jne       L1L114
        loop   L1L114
   ;
   ;          }
   ;
   ;    /* now write any leftover bits */
   ;    /* use fixed mask */
   ;       c= *offscreen;
   ;
        mov     ah,byte ptr es:[si]
   ;
   ;       *video= fixmask[bits & 7];
   ;
        and     bits,7
        mov     al,byte ptr [fixmask][bits]
L1L198:
   ;     mov     byte ptr es:[di],al
        stosb
        mov     byte ptr es:[si],0xff
   ;
   ;
   ;    }
   ;

        exitf
        end
