;   powerc assembly

   idt hline3
   ldef hline3

small define 1
SAVESIDI define 0    ; c saves si,di

   include e:\powerc\macro.asm

   dorg $
;static int fixmask[8]={       /* precalculated masks for final write */
;  0,0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe };

fixmask   db 0,080h,0c0h,0e0h,0f0h,0f8h,0fch,0feh


;/* horizontal line in write mode 3 */
;void hline3(int x, int y, int bits){
   org $
hline3
   enter 0     ;macro   local size, si, di

;char far * video;
;unsigned offset;
;int mask;
;register int i;
;char c;

bits define bx
;mask define [bp][-2]
mask define si

;   bits+= 1;               /* write end point also */
    getarg bits,3
;    inc bits   no longer writing endpoint

;   offset= 80*y+(x >> 3);        /* determine 1st bit position */
    getarg ax,2
    mov    dx,80
    imul   dx
    getarg dx,1
    mov    cx,dx
    sar    cx,1
    sar    cx,1
    sar    cx,1
    add    ax,cx
    mov    di,ax

;   i= x & 7;
    and    dx,7
    mov    cl,dl

;   video= MK_FP( 0xa000, offset );
    mov   ax,0a000h
    mov   es,ax
    cld               ; inc up

;   mask= 0xff >> i;
    mov    ax,255
    sar    ax,cl
    mov    mask,ax

;   if( bits + i <= 8 ){                /* just need one write ?? */
    mov    ax,dx
    add    ax,bits
    cmp    ax,8
    jg     more1

;      mask= mask ^ ( mask >> bits );
       mov   ax,mask
       mov   cx,bits
       sar   ax,cl
       xor   ax,mask

;      c= *video;
       mov   ah, byte ptr es:[di]

;      *video= mask;
       stosb

;      return;
       jump done
;      }

more1:
;   bits= bits + i - 8;          /* else more bits in next address */
    mov  ax,-8
    add  ax,dx
    add  bits,ax

;/* set the latches and write the 1st partial bits */
;   c= *video;
    mov ah,byte ptr es:[di]

;   *video++= mask;
    mov   ax,mask
    stosb
;
;/* write 8 bits at a time, read into latches not needed */
;   i= bits >> 3;
    mov   cx,bits
    sar   cx,1
    sar   cx,1
    sar   cx,1

;#ifdef TURBO
;   while( i-- ) *video++= 0xff;
;#else
;   farmemset(video,0xffff,i);
;   video+= i;
;#endif
    mov  al,255
    rep
    stosb

;/* now write any leftover bits */
;/* use fixed mask */
;   c= *video;
    mov  ah, byte ptr es:[di]

;   *video= fixmask[bits & 7];
    and   bits,7
    mov   al,byte ptr [fixmask][bits]
    stosb

;}

done:
   exitf      ;macro - goes with enter
   end
